﻿local L = AceLibrary("AceLocale-2.2"):new("RecountFu_Options");

L:RegisterTranslations("enUS", function() return {
	["Reset"] = true,
	["Resets the data"] = true,
	["VerChk"] = true,
	["Displays the versions of players in the raid"] = true,
	["Show"] = true,
	["Shows the main window"] = true,
	["Hide"] = true,
	["Hides the main window"] = true,
	["Toggle"] = true,
	["Toggles the main window"] = true,
	["Report"] = true,
	["Allows the data of a window to be reported"] = true,
	["Detail"] = true,
	["Reports the Detail Window Data"] = true,
	["Main"] = true,
	["Reports the Main Window Data"] = true,
	["Select View Mode..."] = true,
	["Select which view mode to display."] = true,
	["Config"] = true,
	["Shows the config window"] = true,
	["ResetPos"] = true,
	["Resets the positions of the detail, graph, and main windows"] = true,
	["Lock"] = true,
	["Toggles windows being locked"] = true,
	["|cffff4040Disabled|r"] = true,
	["|cff40ff40Enabled|r"] = true,
	["Unknown Spells"] = true,
	["Shows found unknown spells in BabbleSpell"] = true,
	["Realtime"] = true,
	["Specialized Realtime Graphs"] = true,
	["FPS"] = true,
	["Starts a realtime window tracking your FPS"] = true,
	["Lag"] = true,
	["Starts a realtime window tracking your latency"] = true,
	["Upstream Traffic"] = true,
	["Starts a realtime window tracking your upstream traffic"] = true,
	["Downstream Traffic"] = true,
	["Starts a realtime window tracking your downstream traffic"] = true,
	["Available Bandwidth"] = true,
	["Starts a realtime window tracking amount of available AceComm bandwidth left"] = true,
	["Raid"] = true,
	["Tracks your entire raid"] = true,
	["DPS"] = true,
	["Tracks Raid Damage Per Second"] = true,
	["DTPS"] = true,
	["Tracks Raid Damage Taken Per Second"] = true,
	["HPS"] = true,
	["Tracks Raid Healing Per Second"] = true,
	["HTPS"] = true,
	["Tracks Raid Healing Taken Per Second"] = true,
	["Text Options"] = true,
	["Options for Displaying Text in Fubar"] = true,
	["Update Frequency"] = true,
	["How Frequently to update text on the Fubar Toolbar (In Seconds)"] = true,
	["Show DPS"] = true,
	["Show DPS in Fubar Toolbar"] = true,
	["Self/Raid DPS"] = true,
	["Show Self or Raid DPS"] = true,
	["SelfDPS"] = true,
	["RaidDPS"] = true,
	["DPS Type"] = true,
	["Pick DPS type Output to Fubar"] = true,
	["Overall"] = true,
	["Last Fight"] = true,
} end);

L:RegisterTranslations("zhCN", function() return {
	["Reset"] = "重置统计数据",
	["Resets the data"] = "重置统计数据",
	["VerChk"] = "版本检查",
	["Displays the versions of players in the raid"] = "显示团队成员安装的Recount版本",
	["Show"] = "显示Recount",
	["Shows the main window"] = "显示Recount主窗体",
	["Hide"] = "隐藏Recount",
	["Hides the main window"] = "隐藏Recount主窗体",
	["Toggle"] = "切换显示/隐藏Recount",
	["Toggles the main window"] = "切换Recount主窗体的显示与否",
	["Report"] = "报告",
	["Allows the data of a window to be reported"] = "发送统计结果的数据报告到指定频道",
	["Detail"] = "详细",
	["Reports the Detail Window Data"] = "发送详细数据报告",
	["Main"] = "主要",
	["Reports the Main Window Data"] = "只发送主窗体上显示的统计数据报告",
	["Select View Mode..."] = "选择数据统计类别...",
	["Select which view mode to display."] = "选择要查看的战斗统计数据的类别。",
	["Config"] = "设置",
	["Shows the config window"] = "显示设置窗口",
	["ResetPos"] = "重置位置",
	["Resets the positions of the detail, graph, and main windows"] = "恢复各个窗体的默认显示位置",
	["Lock"] = "锁定",
	["Toggles windows being locked"] = "锁定/解锁窗体的显示位置",
	["|cffff4040Disabled|r"] = "|cffff4040关闭|r",
	["|cff40ff40Enabled|r"] = "|cff40ff40开启|r",
	["Unknown Spells"] = "未知法术",
	["Shows found unknown spells in BabbleSpell"] = "显示BabbleSpell库中找到的未知法术",
	["Realtime"] = "实时图表",
	["Specialized Realtime Graphs"] = "显示专业的实时统计图表",
	["FPS"] = "每秒帧数FPS",
	["Starts a realtime window tracking your FPS"] = "开启一个实时监控每秒帧数FPS的图表",
	["Lag"] = "延时",
	["Starts a realtime window tracking your latency"] = "开启一个实时监控网络延时的图表",
	["Upstream Traffic"] = "上行传输",
	["Starts a realtime window tracking your upstream traffic"] = "开启一个实时监控网络上行传输情况的图表",
	["Downstream Traffic"] = "下行传输",
	["Starts a realtime window tracking your downstream traffic"] = "开启一个实时监控网络下行传输情况的图表",
	["Available Bandwidth"] = "可用带宽",
	["Starts a realtime window tracking amount of available AceComm bandwidth left"] = "开启一个实时监控AceComm可用带宽情况的图表",
	["Raid"] = "团队",
	["Tracks your entire raid"] = "监视整个团队",
	["DPS"] = "每秒伤害DPS",
	["Tracks Raid Damage Per Second"] = "开启一个实时监控团队平均每秒伤害量的图表",
	["DTPS"] = "每秒承受伤害DTPS",
	["Tracks Raid Damage Taken Per Second"] = "开启一个实时监控团队平均每秒承受伤害量的图表",
	["HPS"] = "每秒治疗HPS",
	["Tracks Raid Healing Per Second"] = "开启一个实时监控团队平均每秒治疗量的图表",
	["HTPS"] = "每秒接受治疗HTPS",
	["Tracks Raid Healing Taken Per Second"] = "开启一个实时监控团队平均每秒接受治疗量的图表",
	["Text Options"] = "Fubar文本显示选项",
	["Options for Displaying Text in Fubar"] = "设定 Fubar 上的文本显示内容",
	["Update Frequency"] = "刷新频率",
	["How Frequently to update text on the Fubar Toolbar (In Seconds)"] = "设定 Fubar 信息面板上文字的刷新频率(以秒为单位)",
	["Show DPS"] = "显示 DPS",
	["Show DPS in Fubar Toolbar"] = "在 Fubar 信息面板上直接显示DPS数据",
	["Self/Raid DPS"] = "自身/团队 DPS",
	["Show Self or Raid DPS"] = "显示自身/团队 DPS",
	["SelfDPS"] = "自身DPS",
	["RaidDPS"] = "团队DPS",
	["DPS Type"] = "DPS 类别",
	["Pick DPS type Output to Fubar"] = "选择 Fubar 信息面板上显示的DPS数据类别",
	["Overall"] = "全部战斗数据",
	["Last Fight"] = "仅当前战斗数据",
} end);

L:RegisterTranslations("zhTW", function() return {
	["Reset"] = "重置統計數據",
	["Resets the data"] = "重置統計數據",
	["VerChk"] = "版本檢查",
	["Displays the versions of players in the raid"] = "顯示團隊成員安裝的 Recount 版本",
	["Show"] = "顯示 Recount",
	["Shows the main window"] = "顯示 Recount 主視窗",
	["Hide"] = "隱藏 Recount",
	["Hides the main window"] = "隱藏 Recount 主視窗",
	["Toggle"] = "切換顯示/隱藏 Recount",
	["Toggles the main window"] = "切換 Recount 主視窗顯示與否",
	["Report"] = "報告",
	["Allows the data of a window to be reported"] = "發送統計結果的數據報告到指定頻道",
	["Detail"] = "詳細",
	["Reports the Detail Window Data"] = "發送詳細數據報告",
	["Main"] = "主要",
	["Reports the Main Window Data"] = "只發送主視窗上顯示的統計數據報告",
	["Select View Mode..."] = "選擇數據統計類別...",
	["Select which view mode to display."] = "選擇要查看的戰鬥統計數據的類別",
	["Config"] = "設置",
	["Shows the config window"] = "顯示設置視窗",
	["ResetPos"] = "重置位置",
	["Resets the positions of the detail, graph, and main windows"] = "重置各個視窗的預設顯示位置",
	["Lock"] = "鎖定",
	["Toggles windows being locked"] = "鎖定/解鎖視窗的顯示位置",
	["|cffff4040Disabled|r"] = "|cffff4040關閉|r",
	["|cff40ff40Enabled|r"] = "|cff40ff40開啟|r",
	["Unknown Spells"] = "未知法術",
	["Shows found unknown spells in BabbleSpell"] = "顯示 BabbleSpell 庫中找到的未知法術",
	["Realtime"] = "即時圖表",
	["Specialized Realtime Graphs"] = "顯示專業的即時統計圖表",
	["FPS"] = "每秒張數 FPS",
	["Starts a realtime window tracking your FPS"] = "開啟一個即時監控每秒張數 FPS 的圖表",
	["Lag"] = "延遲",
	["Starts a realtime window tracking your latency"] = "開啟一個即時監控網路延遲的圖表",
	["Upstream Traffic"] = "上行傳輸",
	["Starts a realtime window tracking your upstream traffic"] = "開啟一個即時監控網路上行傳輸情況的圖表",
	["Downstream Traffic"] = "下行傳輸",
	["Starts a realtime window tracking your downstream traffic"] = "開啟一個即時監控網路下行傳輸情況的圖表",
	["Available Bandwidth"] = "可用頻寬",
	["Starts a realtime window tracking amount of available AceComm bandwidth left"] = "開啟一個即時監控 AceComm 可用頻寬情況的圖表",
	["Raid"] = "團隊",
	["Tracks your entire raid"] = "監視整個團隊",
	["DPS"] = "每秒傷害 DPS",
	["Tracks Raid Damage Per Second"] = "開啟一個即時監控團隊平均每秒傷害量的圖表",
	["DTPS"] = "每秒承受傷害 DTPS",
	["Tracks Raid Damage Taken Per Second"] = "開啟一個即時監控團隊平均每秒承受傷害量的圖表",
	["HPS"] = "每秒治療 HPS",
	["Tracks Raid Healing Per Second"] = "開啟一個即時監控團隊平均每秒治療量的圖表",
	["HTPS"] = "每秒接受治療 HTPS",
	["Tracks Raid Healing Taken Per Second"] = "開啟一個即時監控團隊平均每秒接受治療量的圖表",
	["Text Options"] = "Fubar 文字顯示選項",
	["Options for Displaying Text in Fubar"] = "設定 Fubar 上的文字顯示內容",
	["Update Frequency"] = "更新頻率",
	["How Frequently to update text on the Fubar Toolbar (In Seconds)"] = "設定 Fubar 訊息面板上文字的更新頻率(以秒為單位)",
	["Show DPS"] = "顯示 DPS",
	["Show DPS in Fubar Toolbar"] = "在 Fubar 訊息面板上直接顯示 DPS 數據",
	["Self/Raid DPS"] = "自身/團隊 DPS",
	["Show Self or Raid DPS"] = "顯示自身/團隊 DPS",
	["SelfDPS"] = "自身 DPS",
	["RaidDPS"] = "團隊 DPS",
	["DPS Type"] = "DPS 類別",
	["Pick DPS type Output to Fubar"] = "選擇 Fubar 訊息面板上顯示的 DPS 數據類別",
	["Overall"] = "全部戰鬥數據",
	["Last Fight"] = "僅當前戰鬥數據",
} end);

RecountFu.consoleOptions = {
  type = 'group',
  args = {
    reset = {
      name = L["Reset"],
      desc = L["Resets the data"],
      type = 'execute',
      func = function() Recount:ResetData() end
    },
    verchk = {
      name = L["VerChk"],
      desc = L["Displays the versions of players in the raid"],
      type = 'execute',
      func = function() Recount:Print("Displaying Versions") if Recount.VerTable~=nil then for k,v in pairs(Recount.VerTable) do Recount:Print(k.." "..v) end end end
    },
    show = {
      name = L["Show"],
      desc = L["Shows the main window"],
      type = 'execute',
      func = function() Recount.MainWindow:Show();Recount:RefreshMainWindow() end
    },
    hide = {
      name = L["Hide"],
      desc = L["Hides the main window"],
      type = 'execute',
      func = function() Recount.MainWindow:Hide() end
    },
    toggle = {
      name = L["Toggle"],
      desc = L["Toggles the main window"],
      type = 'execute',
      func = function() if Recount.MainWindow:IsShown() then Recount.MainWindow:Hide() else Recount.MainWindow:Show();Recount:RefreshMainWindow() end end
    },
    report = {
      name = L["Report"],
      type = 'group',
      desc = L["Allows the data of a window to be reported"],
      args = {
        detail = {
          name = L["Detail"],
          desc = L["Reports the Detail Window Data"],
          type = 'execute',
          func = function()  Recount:ShowReport("Detail",Recount.ReportDetail) end
        },
        main ={
          name = L["Main"],
          desc = L["Reports the Main Window Data"],
          type = 'execute',
          func = function()  Recount:ShowReport("Main",Recount.ReportData) end
        }
      }
    },
    selectmode = {
      name = L["Select View Mode..."],
      type = 'group',
      desc = L["Select which view mode to display."],
      args = {
		-- Elsia: These will be now auto-generated from Recount's MainWindowModes
      }
    },      
    config = {
      name = L["Config"],
      desc = L["Shows the config window"],
      type = 'execute',
      func = function() Recount:ShowConfig() end
    },
    resetpos = {
      name = L["ResetPos"],
      desc = L["Resets the positions of the detail, graph, and main windows"],
      type = 'execute',
      func = function() Recount:ResetPositions() end
    },
    lock = {
      name  = L["Lock"],
      desc = L["Toggles windows being locked"],
      type = 'toggle',
      get = function() return Recount.db.char.Locked end,
      set = function(v)
        Recount.db.char.Locked=v 
        Recount:LockWindows(v)
      end,
      map = { [false] = L["|cffff4040Disabled|r"], [true] = L["|cff40ff40Enabled|r"] }
    },
    unknownSpells = {
      name = L["Unknown Spells"],
      desc = L["Shows found unknown spells in BabbleSpell"],
      type = 'execute',
      func = function() Recount:Print("Unknown Spells:");for k in pairs(Recount.UnknownSpells) do Recount:Print(k) end end
    },
    realtime = {
      name = L["Realtime"],
      type = 'group',
      desc = L["Specialized Realtime Graphs"],
      args = {
        fps = {
          name = L["FPS"],
          desc = L["Starts a realtime window tracking your FPS"],
          type = 'execute',
          func = function() Recount:CreateRealtimeWindow("FPS","FPS","") end
        },
        lag = {
          name = L["Lag"],
          desc = L["Starts a realtime window tracking your latency"],
          type = 'execute',
          func = function() Recount:CreateRealtimeWindow("Latency","LAG","") end
        },
        uptraffic = {
          name = L["Upstream Traffic"],
          desc = L["Starts a realtime window tracking your upstream traffic"],
          type = 'execute',
          func = function() Recount:CreateRealtimeWindow("Upstream Traffic","UP_TRAFFIC","") end
        },
        downtraffic = {
          name = L["Downstream Traffic"],
          desc = L["Starts a realtime window tracking your downstream traffic"],
          type = 'execute',
          func = function() Recount:CreateRealtimeWindow("Downstream Traffic","DOWN_TRAFFIC","") end
        },
        bandwidth = {
          name = L["Available Bandwidth"],
          desc = L["Starts a realtime window tracking amount of available AceComm bandwidth left"],
          type = 'execute',
          func = function() Recount:CreateRealtimeWindow("Bandwidth Available","AVAILABLE_BANDWIDTH","") end
        },
        raid = {
          name = L["Raid"],
          desc = L["Tracks your entire raid"],
          type = 'group',

          args = {
            dps = {
              name = L["DPS"],
              desc = L["Tracks Raid Damage Per Second"],
              type = 'execute',
              func = function() Recount:CreateRealtimeWindow("!RAID","DAMAGE","Raid DPS") end
            },
            dtps = {
              name = L["DTPS"],
              desc = L["Tracks Raid Damage Taken Per Second"],
              type = 'execute',
              func = function() Recount:CreateRealtimeWindow("!RAID","DAMAGETAKEN","Raid DTPS") end
            },
            hps = {
              name = L["HPS"],
              desc = L["Tracks Raid Healing Per Second"],
              type = 'execute',
              func = function() Recount:CreateRealtimeWindow("!RAID","HEALING","Raid HPS") end
            },
            htps = {
              name = L["HTPS"],
              desc = L["Tracks Raid Healing Taken Per Second"],
              type = 'execute',
              func = function() Recount:CreateRealtimeWindow("!RAID","HEALINGTAKEN","Raid HTPS") end
            },
          }
        }
      }
    },
    --Added by Physical
    textOptions = {
      name = L["Text Options"],
      desc = L["Options for Displaying Text in Fubar"],
      type = 'group',
      args = {
            Update_Time = {
                  type = 'range',
                  name = L["Update Frequency"],
                  desc = L["How Frequently to update text on the Fubar Toolbar (In Seconds)"],
                  get = function() return RecountFu.db.profile.text.update_time end,
                  set = function(v) RecountFu.db.profile.text.update_time = v; RecountFu:UpdateTimeChanged() end,
                  min = 0.1,
                  max = 5,
                  step = 0.1,
                  order = 3,
            },      
            DPS = {
                type = 'toggle',
                name = L["Show DPS"],
                desc = L["Show DPS in Fubar Toolbar"],
                get = function() return RecountFu.db.profile.text.show_dps end,
                set = function(v) RecountFu.db.profile.text.show_dps = v; RecountFu:UpdateText(); RecountFu:UpdateTimeChanged() end,
                order = 1
            },
			DPS_Raid = {
					type = 'text',
                    name = L["Self/Raid DPS"],
                    desc = L["Show Self or Raid DPS"],
					get = function() return RecountFu.db.profile.text.dps_raid end,
					set = function(v) RecountFu.db.profile.text.dps_raid = v; RecountFu:UpdateText() end,
					validate = {
                        SelfDPS = L["SelfDPS"],
                        RaidDPS = L["RaidDPS"]
                    },
					order = 1
                },
            DPS_Type = {
					type = 'text',
                    name = L["DPS Type"],
                    desc = L["Pick DPS type Output to Fubar"],
					get = function() return RecountFu.db.profile.text.dps_type end,
					set = function(v) RecountFu.db.profile.text.dps_type = v; RecountFu:UpdateText() end,
					validate = {
                        Overall = L["Overall"],
                        LastFight = L["Last Fight"]
                    },
					order = 2
                },
            },
        }, 
      }
    --End Add
}

for k,v in pairs(Recount.MainWindowData) do
	RecountFu.consoleOptions.args.selectmode.args["selectmode"..k]=
	{
		name = v[1],
		desc = "Displays the "..v[1].." mode.",
		type = 'execute',
		func = function() Recount:SetMainWindowMode(k)  end
	}
end


RecountFu.OnMenuRequest = RecountFu.consoleOptions;
RecountFu:RegisterChatCommand({"/recfu"}, RecountFu.consoleOptions)